# __gnu_cxx::_Rope_RopeRep< _CharT, _Alloc > Struct Template Reference

Inheritance diagram for __gnu_cxx::_Rope_RopeRep< _CharT, _Alloc >:

List of all members.

## Detailed Description

### template<class _CharT, class _Alloc>
struct __gnu_cxx::_Rope_RopeRep< _CharT, _Alloc >

Definition at line 554 of file rope.

## Public Types

- typedef _Rope_RopeConcatenation<
  _CharT, _Alloc > __C
- typedef _Rope_RopeFunction<
  _CharT, _Alloc > __F
- typedef _Rope_RopeLeaf< _CharT,
  _Alloc > __L
- typedef _Rope_RopeSubstring<
  _CharT, _Alloc > __S
- typedef _Alloc::template rebind<
  __C >::other _CAlloc
- typedef _Alloc::template rebind<
  _CharT >::other _DataAlloc
- typedef _Alloc::template rebind<
  __F >::other _FAlloc
- typedef _Alloc::template rebind<
  __L >::other _LAlloc
- typedef _Alloc::template rebind<
  __S >::other _SAlloc
- typedef _Rope_rep_base< _CharT,
  _Alloc >::allocator_type allocator_type

## Public Member Functions

- void _M_free_c_string ()
- void _M_free_tree ()
- void _M_ref_nonnil ()
- void _M_unref_nonnil ()
- _Rope_RopeRep (__detail::_Tag __t, int __d, bool __b, size_t __size, allocator_type __a)
- allocator_type get_allocator () const

## Static Public Member Functions

- static __C * _C_allocate (size_t __n)
- static void _C_deallocate (__C *__p, size_t __n)
- static _CharT * _Data_allocate (size_t __n)
- static void _Data_deallocate (_CharT *__p, size_t __n)
- static __F * _F_allocate (size_t __n)
- static void _F_deallocate (__F *__p, size_t __n)
- static __L * _L_allocate (size_t __n)
- static void _L_deallocate (__L *__p, size_t __n)
- static __S * _S_allocate (size_t __n)
- static void _S_deallocate (__S *__p, size_t __n)
- static void _S_free_if_unref (_Rope_RopeRep *__t)
- static void _S_free_string (_CharT *, size_t __len, allocator_type __a)
- static void _S_ref (_Rope_RopeRep *__t)
- static void _S_unref (_Rope_RopeRep *__t)

## Public Attributes

- _CharT * _M_c_string
- __gthread_mutex_t _M_c_string_lock
- unsigned char _M_depth
- bool _M_is_balanced:8
- size_t _M_size
- __detail::_Tag _M_tag:8

## Protected Member Functions

- _Rope_RopeRep (const _Rope_RopeRep &)
- _Rope_RopeRep & operator= (const _Rope_RopeRep &)

The documentation for this struct was generated from the following files:

- rope
- ropeimpl.h